(function(owner) {
	// 如“alipay”表示支付宝、“wxpay”表示微信支付、“appleiap”表示苹果应用内支付
	var Payment = {
			paymentchannels: {},
			alipay: null,
			wxpay: null,
			appleiap: null,
			init: function() {
				if (mui.os.plus) {
					mui.plusReady(function() {
					    // 获取支付通道
					    plus.payment.getChannels(function(channels){
					    	this.paymentchannels = {};
							for(var i in channels){
								var channel=channels[i];
								this.paymentchannels[channel.id] = channel;
								if(channel.id==='appleiap'){
									this.appleiap=channel;
								}
							}
					    }.bind(this),function(e){
					        console.log("获取支付通道失败："+e.message);
					    });
					}.bind(this));
				}
			},
			// 2. 发起支付请求
			pay: function(order_id, id, callback){
				//console.log(order_id);
				var ALIPAYSERVER='http://thdeer2017.chinacloudapp.cn:8080/app/payment/alipay';
				var WXPAYSERVER='http://thdeer2017.chinacloudapp.cn:8080/app/payment/wxpay';
			    // 从服务器请求支付订单
			    var PAYSERVER='';
			    var channel = null;
			    if(id=='alipay'){
			        PAYSERVER=ALIPAYSERVER;
			    }else if(id=='wxpay'){
			        PAYSERVER=WXPAYSERVER;
			    }else{
			        plus.nativeUI.alert("不支持此支付通道！",null,"捐赠");
			        return;
			    }
			    
			    channel = this.paymentchannels[id];
			    if(!channel){
			    	plus.nativeUI.alert('无效的支付方式[' + id + ']');
			    	return;
			    }
			    PAYSERVER = PAYSERVER + "?order_id=" + order_id;
			    var xhr=new XMLHttpRequest();
			    xhr.onreadystatechange=function(){
			        switch(xhr.readyState){
			            case 4:
			            if(xhr.status==200){
			            	console.log(xhr.responseText);
			                plus.payment.request(channel,xhr.responseText,function(result){
			                	console.log(JSON.stringify(result));
			                	if(typeof callback == "function"){
			                		callback();
			                		return ;
			                	}
			                    plus.nativeUI.alert("支付成功！",function(){
			                    });
			                },function(error){
			                	console.log(JSON.stringify(error));
			                    plus.nativeUI.alert(error.code == -100 ? "您已取消支付" : "支付失败");
			                });
			            }else{
			                alert("获取订单信息失败！");
			            }
			            break;
			            default:
			            break;
			        }
			    }
			    xhr.open('GET',PAYSERVER);
			    xhr.send(null);
			}
	}
	Payment.init();
	owner.payment = Payment;
})(window);