var api_upload_url = app.apiurl + 'upload/singleimg';
var api_upload_url2 = app.apiurl + 'upload/singlepic';
function getimg(options) {
	var options = options || {};
	options.uploadurl = options.uploadurl || api_upload_url;
	if( options.camera ){
				var cmr = plus.camera.getCamera();
				cmr.captureImage(function(path) {
	             	path = "file://" + plus.io.convertLocalFileSystemURL(path);
	             	options.path = path;
					appendFile(options, 0);
				}, function(err) {});
				return;
	}
	var btnArray = [{
		title: "拍照"
	}, {
		title: "从相册选择"
	}];
	plus.nativeUI.actionSheet({
		title: "选择照片",
		cancel: "取消",
		buttons: btnArray
	}, function(e) {
		var index = e.index;
		switch (index) {
			case 0:
				break;
			case 1:
				var cmr = plus.camera.getCamera();
				cmr.captureImage(function(path) {
	             	path = "file://" + plus.io.convertLocalFileSystemURL(path);
	             	options.path = path;
					appendFile(options, 0);
				}, function(err) {});
				break;
			case 2:
				if(options.multiple){
					var limit = options.limit || 9;
				    plus.gallery.pick( function(e){
				    	for(var i in e.files){
				    		if(i < limit){
					    		options.path = e.files[i];
					    		appendFile(options, i);
				    		}
	//			    		appendFile(e.files[i],options);
					    	//console.log(e.files[i]);
				    	}
				    }, function ( e ) {
				    	//console.log( "取消选择图片" );
				    },{filter:"image",multiple:true,maximum:limit,onmaxed:function(){
						plus.nativeUI.alert('最多只能选择'+limit+'张图片');
					}});
			    }else{
					plus.gallery.pick(function(path) {
		             	options.path = path;
						appendFile(options, 0);
					}, function(err) {}, null);
			    }
				break;
		}
	});
}
					
// 拍照添加文件
function appendByCamera(options){
	var options = options || {};
	options.uploadurl = options.uploadurl || api_upload_url;
	var cmr = plus.camera.getCamera();
	cmr.captureImage(function(path) {
     	path = "file://" + plus.io.convertLocalFileSystemURL(path);
     	options.path = path;
		appendFile(options, 0);
	}, function(err) {});
}

function appendFile(options, i){
	if(options && options.cropper && !options.multiple){
		cropperimg(options);
	}else{
		uploadImg(options, i);
	}
}

function appendFile2(options, i){
		var degree = getImgOrientation(options.path);
//		console.log("degree " + degree);
//		alert(degree);
		p = options.path;
		var dst = !i ? "_downloads/dst.png" : "_downloads/dst"+ i +".png";
		plus.zip.compressImage({
				"src":p,
				"dst":dst,
				"format":"png",
				"width":"480px",
				"rotate":degree,
				"quality":50,
				"overwrite":true
			},
			function(event) {
				options.path = event.target;
//				alert(options.path);
				uploadFile(options);
			},function(error) {
				uploadFile(options);
		});
}

function cropperimg(options){
	var ws = plus.webview.currentWebview();
	// 开启遮罩
	ws.setStyle({mask:"rgba(0,0,0,0.5)"});
	
	// 创建侧滑页面
	//wc=plus.webview.create("/plus/index.html","cropper",{popGesture:"none"});
	var wc = plus.webview.getWebviewById('cropper');
	if(wc)
	{
		//wc.setStyle({popGesture:"none"}); 
		mui.fire(wc,"initpage",options);
		wc.show();
		wc.addEventListener('hide',function(){
			ws.setStyle({mask:"none"});
			wc=null;
		},false);
		wc.addEventListener('close',function(){
			ws.setStyle({mask:"none"});
			wc=null;
		},false);
	}else{
		wc = plus.webview.create("/plus/crop.html","cropper",{popGesture:"none"});
		wc.addEventListener("loaded",function(){
			mui.fire(wc,"initpage",options);
			wc.show();
			//wc.show("slide-in-right",200);
		},false);
		wc.addEventListener('hide',function(){
			ws.setStyle({mask:"none"});
			wc=null;
		},false);
		wc.addEventListener('close',function(){
			ws.setStyle({mask:"none"});
			wc=null;
		},false);
	}
	
	
	// 侧滑页面关闭后关闭遮罩
//	wc.addEventListener('close',function(){
//		ws.setStyle({mask:"none"});
//		wc=null;
//	},false);
	// 侧滑页面加载后显示（避免白屏）
//	wc.addEventListener("loaded",function(){
//		wc.show("slide-in-right",200);
//	},false);

}

//function appendFile(p,options){
//	var degree = getImgOrientation(p);
//	options.degree = degree;
//	plus.zip.compressImage({
//			src:p,
//			dst:p,
//			//width:"800px",
//			quality:60,
//			overwrite:true
//		},
//		function(event) {
//			uploadFile(p,options);
//		},function(error) {
//			uploadFile(p,options);
//	});
//}
// 上传文件
function uploadFile(options){
var server = options.uploadurl;
	var task=plus.uploader.createUpload(server,
		{method:"POST"},
		function(t,status){ //上传完成
			plus.nativeUI.closeWaiting();
			if(status==200){
				if(options.callback){
					options.callback(t.responseText);
				}
//					console.log(t.responseText);
					mui.toast("上传成功");
			}else{
				mui.toast("上传失败");
			}
		}
	);
	task.addFile(options.path,{"key":"file"});
//	task.addData('degree',options.degree);
	if(options.data){
		for(var jk in options.data){
			task.addData(jk,options.data[jk]);
		}		
	}
	plus.nativeUI.showWaiting('上传图片。。。');
	task.start();
}


function getImgOrientation (filePath) {
	if(plus.os.name == 'iOS'){ 
		var degree = 0;
//			CGImageSourceRef _imageRef;
//			(UIImageOrientation)imageOrientation;
//      	_imageRef = CGImageSourceCreateWithURL((CFURLRef)imageUrl, NULL);
//      	_imageProperty = (NSDictionary*)CGImageSourceCopyPropertiesAtIndex(_imageRef, 0, NULL);
//			return [[_imageProperty valueForKey:(NSString*)kCGImagePropertyOrientation] intValue];
			
			
			//NSURL *modelURL = [[NSBundle mainBundle] URLForResource:@"rails.png" withExtension:nil];  
			//CGImageSourceRef myImageSource = CGImageSourceCreateWithURL((CFURLRef)modelURL, NULL);  
			//CFDictionaryRef imagePropertiesDictionary = CGImageSourceCopyPropertiesAtIndex(myImageSource,0, NULL);  
			//CFNumberRef imageWidth = (CFNumberRef)CFDictionaryGetValue(imagePropertiesDictionary, kCGImagePropertyPixelWidth);  
			//CFNumberRef imageHeight = (CFNumberRef)CFDictionaryGetValue(imagePropertiesDictionary, kCGImagePropertyPixelHeight);  
			//NSLog(@"%@", imagePropertiesDictionary);  
			
//			var CGImageSourceRef  = plus.ios.importClass("CGImageSourceRef");
//			CGImageSourceRef cGImageSourceRef = new CGImageSourceRef();
//			cGImageSourceRef = cGImageSourceRef.CGImageSourceCreateWithURL(filePath, NULL);
			
		return degree; 
	}
            var ExifInterface = plus.android.importClass("android.media.ExifInterface");
            var exifInterface = new ExifInterface(filePath.replace("file:///", ""));
            var orientation = exifInterface.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
            var degree = 0;
            switch (orientation) {
                case ExifInterface.ORIENTATION_ROTATE_90:
                    degree = 90;
                    break;
                case ExifInterface.ORIENTATION_ROTATE_180:
                    degree = 180;
                    break;
                case ExifInterface.ORIENTATION_ROTATE_270:
                    degree = 270;
                    break;
            }
            return degree;
        }

function uploadImg(options, i){
	plus.nativeUI.showWaiting("上传中。。。");
	var width = (options.data && options.data.width) ? options.data.width : 500;
	var quality = (options.data && options.data.quality) ? options.data.quality : 0.7;
		lrz(options.path, {
//	        width: width,
	        quality: quality
	    })
        .then(function (rst) {
        	/*
        	// 额外添加参数
        	rst.formData.append('fileLen', rst.fileLen);
			if(options.data){
				for(var jk in options.data){
					rst.formData.append(jk, options.data[jk]);
				}		
			}
			$.ajax({
			    url: api_upload_url, // 这个地址做了跨域处理，可以用于实际调试
			    data: rst.formData,
			    processData: false,
			    contentType: false,
			    type: 'POST',
			    success: function (data) {
			        //alert(JSON.stringify(data));
					if(options.callback){
						options.callback(xhr.response);
					}
					mui.toast("上传成功");
			    }
			});
			*/
            // 处理成功会执行
            var xhr = new XMLHttpRequest();
            xhr.open('POST', options.uploadurl);

            xhr.onload = function () {
            	plus.nativeUI.closeWaiting();
                if (xhr.status === 200) {
//                	console.log(xhr.response);
					if(options.callback){
						options.callback(xhr.response);
					}
					mui.toast("上传成功");
                    // 上传成功
                    //img.src        = rst.base64;
                } else {
                    // 处理错误
                   	 //console.info(xhr.response);
                    var data = JSON.parse(xhr.response);
                    mui.toast(data.info);
                }
            };
            xhr.onerror = function (err) {
                mui.toast('未知错误:' + JSON.stringify(err, null, 2));
            };
//          // issues #45 提到似乎有兼容性问题,关于progress
//          if (xhr.upload) {
//              try {
//                  xhr.upload.addEventListener('progress', function (e) {
//                      if (!e.lengthComputable) return false;
//                      // 上传进度
//                      progressvalue = ((e.loaded / e.total) || 0) * 100;
//                  });
//              } catch (err) {
//                  console.error('进度展示出错了,似乎不支持此特性?', err);
//              }
//          }
            // 添加参数
            rst.formData.append('fileLen', rst.fileLen);
            
			if(options.data){
				for(var jk in options.data){
					rst.formData.append(jk, options.data[jk]);
				}		
			}
            // 触发上传
            xhr.send(rst.formData);
            /* ==================================================== */
            return rst;
        })
        .catch(function (err){
            // 处理失败会执行
            //uploadFile(options);
            appendFile2(options, i);
        })
        .always(function () {
            // 不管是成功失败，都会执行
        });
}